<?php 
$tex_inputfiles = array("Jones1970", "Meyer2000", "Smith1964", "Hubert2007", "Douglas1994");

function getCitation($index)
{
  switch ($index)
    {
    case "Jones1970":
      return "T.P.&nbsp;Jones, <em>The Harmful Effects of Tobaco.</em> 1970.";
    case "Meyer2000":
      return "A.&nbsp;Meyer, <em>How to Become Invisible.</em> 2000.";
    case "Smith1964":
      return "H-C.&nbsp;Smith, <em>Eating Soap Can be Dangerous.</em> 1964.";
    case "Hubert2007":
      return "X.&nbsp;Hubert, <em>On Not Becoming a Giant Monster.</em> 2007.";
    case "Douglas1994":
      return "D.&nbsp;Douglas, <em>The Infinite Everything.</em> 1994.";
    default:
      return "<em>invalid selection $index</em>";
    }
}

function getTexInputFiles($list_of_inputfiles, $passed_parameters)
{
  $inputfiles = array();
  foreach ($list_of_inputfiles as $item)
    {
      if ($passed_parameters[$item] == "y" )
        {
          $inputfiles[] = $item;
        }
    }
  return $inputfiles;
}

function sanitize($rawtext)
{
  $safetext = str_replace("\\", "\\textbackslash ", $rawtext);
  $safetext = str_replace("{", "\\{", $safetext);
  $safetext = str_replace("}", "\\}", $safetext);
  $safetext = str_replace("&", "\\&", $safetext);
  $safetext = str_replace("%", "\\%", $safetext);
  return $safetext;
}

function writeTexPreamble($filename, $author, $title, $date)
{
  $ofile = fopen($filename . ".tex", "w");
  fwrite($ofile, "\\documentclass{article}\n");
  fwrite($ofile, "\\input{preamble}\n");
  fwrite($ofile, "\n");
  fwrite($ofile, "\\author{" . sanitize($author) . "}\n");
  fwrite($ofile, "\\title{" . sanitize($title) . "}\n");
  fwrite($ofile, "\\date{" . sanitize($date) . "}\n");
  fwrite($ofile, "");
  fwrite($ofile, "\n");
  fclose($ofile);
}

function writeTexBody($filename, $inputfiles)
{
  $ofile = fopen($filename . ".tex", "a");
  fwrite($ofile, "\\begin{document}\n");
  foreach ($inputfiles as $inputfile)
    {
      fwrite($ofile, "  \\include{" . $inputfile . "}\n");
    }
  fwrite($ofile, "\\end{document}\n");
}

function processTex($filename)
{
  $last_line = exec("pdflatex $filename", $output, $retcode);
  if ($retcode == 0)
    {
      $last_line = exec("pdflatex $filename", $output, $retcode);
    }
  return $retcode;
}

?>
